/*
 * Copyright (c) 1999, 2000 The University of Utah and the Flux Group.
 * All rights reserved.
 *
 * @JANOS_CONFIGURE_GNU_LICENSE@
 *
 * A test case for handling inner classes and blank files.
 * 
 * Each test is copied to 'conftestJavac.java' before the compiler
 * is run over it.
 */

public class conftestJavac
{
	private static final Object staticObj;
	public final int a;
	public InnerClass ic;
	
	private static class InnerStaticClass
	{
		public final Object o;
		
		public InnerStaticClass()
		{
			o = staticObj;
		}
	}
	
	static {
		staticObj = new Object();
	}
	
	private class InnerClass {
		int a;
	}
	
	public static void main(String[] args)
	{
		Object t = new conftestJavac(1);
	}
	
	public conftestJavac(int a) 
	{
		if (a > 2) 
			throw new NullPointerException();
		this.a = a;
		this.ic = new InnerClass();
	}
}
