/*
 * NativeNodeOS.cpp
 *
 * Copyright (c) 1999, 2000 The University of Utah and the Flux Group.
 * All rights reserved.
 * 
 * This file is part of Janos.
 * 
 * Janos is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License, version 2, as
 * published by the Free Software Foundation.
 * 
 * Janos is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details, in the file
 * COPYING.  If that file is not present, write to the Free
 * Software Foundation, 59 Temple Place - Suite 330, Boston, MA  
 * 02111-1307, USA
 * 
 * The University of Utah and the Flux Group requests users to
 * return to flux-dist@cs.utah.edu any improvements that they make.
 */

/*
 * Set of mappings for "native" implementations.
 */

#define ID_JAVA_NODEOS 1
#define ID_C_NODEOS 2


#if defined(pj_NODEOS)
#define NATIVE_NODEOS ID_JAVA_NODEOS
#elif defined(moab_NODEOS)
#define NATIVE_NODEOS ID_C_NODEOS
#else
#error NativeNodeOS: Must pick nodeos impl (pj_NODEOS or moab_NODEOS)
#endif
/* -- */

#if NATIVE_NODEOS == ID_JAVA_NODEOS
#define NATIVE_BUFFERHANDLE		pj_BufferHandle
#define NATIVE_CREDENTIALS		pj_Credentials
#define NATIVE_FLOW			pj_Flow
#define NATIVE_THREAD			pj_Thread
#define NATIVE_THREADPOOL		pj_ThreadPool
#define NATIVE_THREADPOOLSPEC		pj_ThreadPoolSpec
#define NATIVE_MEMSPEC			pj_MemSpec
#define NATIVE_INCHANNEL		pj_InChannel
#define NATIVE_OUTCHANNEL		pj_OutChannel
#define NATIVE_CUTTHROUGHCHANNEL	pj_CutThroughChannel
#define NATIVE_INCHANNELHANDLE		pj_InChannelHandle
#define NATIVE_DEMULTIPLEXKEY		pj_DemultiplexKey
#define NATIVE_DEBUG			pj_Debug
#define NATIVE_SETUP			pj_Setup
#define NATIVE_NODE			pj_Node

#elif NATIVE_NODEOS == ID_C_NODEOS
#define NATIVE_BUFFERHANDLE		moab_BufferHandle
#define NATIVE_CREDENTIALS		moab_Credentials
#define NATIVE_FLOW			moab_Flow
#define NATIVE_THREAD			moab_Thread
#define NATIVE_THREADPOOL		moab_ThreadPool
#define NATIVE_THREADPOOLSPEC		moab_ThreadPoolSpec
#define NATIVE_MEMSPEC			moab_MemSpec
#define NATIVE_INCHANNEL		moab_InChannel
#define NATIVE_OUTCHANNEL		moab_OutChannel
#define NATIVE_CUTTHROUGHCHANNEL	moab_CutThroughChannel
#define NATIVE_INCHANNELHANDLE		moab_InChannelHandle
#define NATIVE_DEMULTIPLEXKEY		moab_DemultiplexKey
#define NATIVE_DEBUG			moab_Debug
#define NATIVE_SETUP			moab_Setup
#define NATIVE_NODE			moab_Node

#endif /* Picking a Native NodeOS */
