/*
 * StatsCapsuleCacheKey.Java
 *
 * Copyright (c) 2000 The University of Utah and the Flux Group.
 * All rights reserved.
 * 
 * This file is part of Janos.
 * 
 * Janos is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License, version 2, as
 * published by the Free Software Foundation.
 * 
 * Janos is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details, in the file
 * COPYING.  If that file is not present, write to the Free
 * Software Foundation, 59 Temple Place - Suite 330, Boston, MA  
 * 02111-1307, USA
 * 
 * The University of Utah and the Flux Group requests users to
 * return to flux-dist@cs.utah.edu any improvements that they make.
 */
package JANOS_ANTSR_STATS_APP_PKG;

import JANOS_ANTSR_CORE_PKG.Node;
import JANOS_ANTSR_CORE_PKG.NodeAddress;

/**
 * @author <a href="mailto:janos-discuss@flux.cs.utah.edu">Janos Ministry of Development</a>
 */
PACKAGE class StatsCapsuleCacheKey
{
	public long id;
	public int root;
	public int dest;

	public StatsCapsuleCacheKey(long id, int root, int dest)
	{
		this.id=id;
		this.root=root;
		this.dest=dest;
	}

	public int hashCode()
	{
		return root;
	}

	public boolean equals(Object o)
	{
		boolean rval = false;
		
		if ((o != null)
		    && o instanceof StatsCapsuleCacheKey)
		{
			StatsCapsuleCacheKey other;
			other = (StatsCapsuleCacheKey)o;

			rval = this.id == other.id
				&& this.root == other.root
				&& this.dest == other.dest;
		}
		return rval;
	}
}
