/* 
 *  $Id: Extension.Java,v 1.3 2000/03/28 22:40:17 stack Exp $
 *
 * Copyright (c) 1999, 2000 The University of Utah and the Flux Group.
 * All rights reserved.
 * 
 * This file is part of Janos.
 * 
 * Janos is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License, version 2, as
 * published by the Free Software Foundation.
 * 
 * Janos is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details, in the file
 * COPYING.  If that file is not present, write to the Free
 * Software Foundation, 59 Temple Place - Suite 330, Boston, MA  
 * 02111-1307, USA
 * 
 * The University of Utah and the Flux Group requests users to
 * return to flux-dist@cs.utah.edu any improvements that they make.
 *  
 *  Copyright 1996 Massachusetts Institute of Technology
 * 
 *  Permission to use, copy, modify, distribute, and sell this software and
 *  its documentation for any purpose is hereby granted without fee, provided
 *  that the above copyright notice appear in all copies and that both that
 *  copyright notice and this permission notice appear in supporting
 *  documentation, and that the name of M.I.T. not be used in advertising or
 *  publicity pertaining to distribution of the software without specific,
 *  written prior permission.  M.I.T. makes no representations about the
 *  suitability of this software for any purpose.  It is provided "as is"
 *  without express or implied warranty.
 * 
 */
package JANOS_ANTSR_CORE_PKG;

import JANOS_ANTSR_UTIL_PKG.KeyArgs;
import JANOS_ANTSR_UTIL_PKG.InvalidKeyArgsException;

import java.util.Hashtable;

/**
 * XXX THIS CLASS IS NEVER USED.
 * <p>
 * The abstract extension class that "real" extensions must
 * subclass.
 * <p>
 * Node extensions augment the built-in services of the node with
 * large components that are not readily transferred on a per capsule
 * basis or are too specialized to be needed at all nodes within the
 * network.  (E.g., multicast extensions, RSVP, etc.)
 * <p>
 * I don't think any extensions have ever been written.
 *
 * @see Capsule#findExtension(java.lang.String)
 * @see Node#attachExtension(Extension)
 * @see Node#getExtensions()
 * @see Node#getExtension(int)
 * @author David Wetherall
 */
public abstract class Extension
	extends Entity
{
	
	final public static String[] defaults = { };

	private Node server;
	public Node thisNode()
	{
		return server;
	}

	private static int count = 0;
	private static Hashtable registry = new Hashtable();

	public static int findNamedExtension(String name)
	{
		Integer index = (Integer)registry.get(name);
		
		if (index != null)
			return index.intValue();
		else
			return -1;
	}  

	public static int registerNamedExtension(String name)
	{
		Integer index = (Integer)registry.get(name);
		
		if (index == null) {
			index = new Integer(count++);
			registry.put(name, index);
		}
		return index.intValue();
	}
  
	public void setArgs(KeyArgs k) 
		throws InvalidKeyArgsException
	{
		k.merge(defaults);
		k.noMore();
	}
 
	/**
	 * Construct a no-name extension.
	 * <p>
	 * Set name through setName().
	 */
	public Extension()
	{
		super();
	} 
}
