/*
 * moab_CutThroughChannel.Java
 *
 * Copyright (c) 2000 The University of Utah and the Flux Group.
 * All rights reserved.
 * 
 * This file is part of Janos.
 * 
 * Janos is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License, version 2, as
 * published by the Free Software Foundation.
 * 
 * Janos is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details, in the file
 * COPYING.  If that file is not present, write to the Free
 * Software Foundation, 59 Temple Place - Suite 330, Boston, MA  
 * 02111-1307, USA
 * 
 * The University of Utah and the Flux Group requests users to
 * return to flux-dist@cs.utah.edu any improvements that they make.
 */
package JANOS_NODEOS_PKG;

import java.io.IOException;

/**
 * Wrapper for Moab CutThroughChannel.
 * 
 * @see CutThroughChannel
 * @author <a href="mailto:janos-discuss@flux.cs.utah.edu">Janos Ministry of Development</a>
 */
PACKAGE class moab_CutThroughChannel
{
	CHECK_NATIVE_NODEOS

	static
	{
		ensureNativeSpace(moab_CutThroughChannel.class);
	}

	private static native void ensureNativeSpace(Class thisclass);

	PACKAGE moab_CutThroughChannel(moab_Flow flow,
				       moab_DemultiplexKey classifier,
				       String inProtocolSpec,
				       String outProtocolSpec,
				       String inAddressSpec,
				       String outAddressSpec,
				       Address destAddr)
		throws IOException,
		PacketAddressFormatException,
		ProtocolSpecFormatException
	{
		int rc;

		/* XXX DEST ADDR?? */

		rc = init(flow, classifier, inProtocolSpec, outProtocolSpec,
			  inAddressSpec, outAddressSpec);
		assert(rc == 0);
	}
	
	private native int init(moab_Flow flow,
				moab_DemultiplexKey classifier,
				String inProtocolSpec,
				String outProtocolSpec,
				String inAddressSpec,
				String outAddressSpec);
	
	PACKAGE native void native_addBuffer(moab_BufferHandle pb);

	PACKAGE native moab_BufferHandle native_remBuffer();
	
	PACKAGE native void destroy();
}


