/*
 * moab_DemultiplexKey.Java
 *
 * Copyright (c) 2000 The University of Utah and the Flux Group.
 * All rights reserved.
 * 
 * This file is part of Janos.
 * 
 * Janos is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License, version 2, as
 * published by the Free Software Foundation.
 * 
 * Janos is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details, in the file
 * COPYING.  If that file is not present, write to the Free
 * Software Foundation, 59 Temple Place - Suite 330, Boston, MA  
 * 02111-1307, USA
 * 
 * The University of Utah and the Flux Group requests users to
 * return to flux-dist@cs.utah.edu any improvements that they make.
 */
package JANOS_NODEOS_PKG;

/**
 * A key for matching incoming packets.
 *
 * @author <a href="mailto:janos-discuss@flux.cs.utah.edu">Janos Ministry of Development</a>
 */
PACKAGE class moab_DemultiplexKey
{
	CHECK_NATIVE_NODEOS

	static
	{
		ensureNativeSpace(moab_DemultiplexKey.class);
	}

	private static native void ensureNativeSpace(Class thisclass);

	private native void init(moab_Flow flow);

	PACKAGE moab_DemultiplexKey(moab_Flow flow)
	{
		require(flow);
		require(flow == moab_Flow.native_currentFlow());
		init(flow);
	}

	PACKAGE native void match(int offset, int length,
				  byte sequence[], boolean mask[]);

	PACKAGE native void matchIPv4(int offset, int source, int dest, int protocol);

	PACKAGE native void matchUDP(int offset, int srcPort, int destPort);

	PACKAGE native void matchTCP(int offset, int srcPort, int destPort);
	
	PACKAGE native void matchANEP(int offset, byte version,
				      boolean allVersions, short protocolID);

	PACKAGE native int matches(byte payload[],
				   int payloadStart,
				   int payloadLength);
	public String toString()
	{
		String retval = "moab_DemultiplexKey[...]";
		return retval;
	}
}
