/*
 * moab_ThreadPool.Java
 *
 * Copyright (c) 1999, 2000 The University of Utah and the Flux Group.
 * All rights reserved.
 * 
 * This file is part of Janos.
 * 
 * Janos is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License, version 2, as
 * published by the Free Software Foundation.
 * 
 * Janos is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details, in the file
 * COPYING.  If that file is not present, write to the Free
 * Software Foundation, 59 Temple Place - Suite 330, Boston, MA  
 * 02111-1307, USA
 * 
 * The University of Utah and the Flux Group requests users to
 * return to flux-dist@cs.utah.edu any improvements that they make.
 */
package JANOS_NODEOS_PKG;

/**
 * NodeOS ThreadPool implementation in Java.
 *
 * XXX CURRENTLY UNUSED BECAUSE THE THREAD POOL IS HIDDEN WITHIN MOAB.
 *
 * @author <a href="mailto:janos-discuss@flux.cs.utah.edu">Janos Ministry of Development</a>
 */
PACKAGE final class moab_ThreadPool
{
	CHECK_NATIVE_NODEOS

	static
	{
		ensureNativeSpace(moab_ThreadPool.class);
		panic("The moab_ThreadPool class should *NEVER BE REFERENCED*.");
	}

	private static native void ensureNativeSpace(Class thisclass);

	PACKAGE moab_ThreadPool(moab_Flow flow,
				moab_ThreadPoolSpec ignoredForNow)
	{
		int rc;
		require(flow);
		rc = init(flow, ignoredForNow);
		assert(rc == 0); // XXX
	}

	private native int init(moab_Flow flow,
				moab_ThreadPoolSpec ignoredForNow);


	PACKAGE native void threadStart(java.lang.Runnable runnable, String name);

	PACKAGE native void destroy();

	PACKAGE native boolean destroyed();
}
