/*
 * pj_ThreadPoolSpec.Java
 *
 * Copyright (c) 1999, 2000 The University of Utah and the Flux Group.
 * All rights reserved.
 * 
 * This file is part of Janos.
 * 
 * Janos is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License, version 2, as
 * published by the Free Software Foundation.
 * 
 * Janos is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details, in the file
 * COPYING.  If that file is not present, write to the Free
 * Software Foundation, 59 Temple Place - Suite 330, Boston, MA  
 * 02111-1307, USA
 * 
 * The University of Utah and the Flux Group requests users to
 * return to flux-dist@cs.utah.edu any improvements that they make.
 */
package JANOS_NODEOS_PKG;

/**
 * NodeOS ThreadPoolSpec implementation in Java
 *
 * @author <a href="mailto:janos-discuss@flux.cs.utah.edu">Janos Ministry of Development</a>
 */
PACKAGE class pj_ThreadPoolSpec
{
	private final int maxThreads;
	private final int stackSize;
	private final ThreadScheduler sched;

	public pj_ThreadPoolSpec(int maxThreads,
				 int stackSize,
				 ThreadScheduler sched)
	{
		require(maxThreads > 1);
		require(stackSize >= 0);
		require(sched);

		this.maxThreads = maxThreads;
		this.stackSize = stackSize;
		this.sched = sched;
	}

	PACKAGE int maxThreads()
	{
		return this.maxThreads;
	}
}
