/*
 * DoWhileCompilerBug.Java
 *
 * Copyright (c) 2000 The University of Utah and the Flux Group.
 * All rights reserved.
 * 
 * This file is part of Janos.
 * 
 * Janos is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License, version 2, as
 * published by the Free Software Foundation.
 * 
 * Janos is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details, in the file
 * COPYING.  If that file is not present, write to the Free
 * Software Foundation, 59 Temple Place - Suite 330, Boston, MA  
 * 02111-1307, USA
 * 
 * The University of Utah and the Flux Group requests users to
 * return to flux-dist@cs.utah.edu any improvements that they make.
 */
package JANOS_TESTS_PKG;


/**
 * Kaffe's KJC compiler has a bug where it cannot distinguish
 * correctly between overloaded methods put(byte), put(short), and
 * put(int).  The XDR code in ANTSR relies heavily on this
 * distinction.
 * <p>
 * Its pretty obvious if you have the bug.
 *
 * @author <a href="mailto:janos-discuss@flux.cs.utah.edu">Janos Ministry of Development</a>
 */
public class OverloadingCompilerBug
{
	private int offset;

	public static void main(String[] args)
	{
		OverloadingCompilerBug o = new OverloadingCompilerBug();

		o.check();
		java.lang.System.exit(0);
	}

	public void put(byte x)
	{
		offset+=1;
	}

	public void put(short y)
	{
		offset+=2;
	}

	public void put(int z)
	{
		offset+=4;
	}

	
	public void checkOffset(int supposedToBe)
	{
		if (offset != supposedToBe)
		{
			System.out.println("Offset should be " +supposedToBe+ ", but is " +offset);
			System.exit(11);
		}
		
		System.out.println("Offset is okay (" +offset+ ").");
	}
	
	public void check()
	{
		offset = 0;
		put((byte)0);  // offset += 1
		put((short)0); // offset += 2
		put((int)0);   // offset += 4
		checkOffset(7);
	}
}
