/*
 * AddressFactoryTester.Java
 *
 * Copyright (c) 1999, 2000 The University of Utah and the Flux Group.
 * All rights reserved.
 * 
 * This file is part of Janos.
 * 
 * Janos is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License, version 2, as
 * published by the Free Software Foundation.
 * 
 * Janos is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details, in the file
 * COPYING.  If that file is not present, write to the Free
 * Software Foundation, 59 Temple Place - Suite 330, Boston, MA  
 * 02111-1307, USA
 * 
 * The University of Utah and the Flux Group requests users to
 * return to flux-dist@cs.utah.edu any improvements that they make.
 */

package JANOS_TESTS_NODEOS_PKG;

import java.net.InetAddress;

import JANOS_TESTS_PKG.*;

import JANOS_NODEOS_PKG.Address;
import JANOS_NODEOS_PKG.AddressFactory;
import JANOS_NODEOS_PKG.NoSuchNodeAddress;

public class AddressFactoryTester extends Tester
{

	public void testUnit() throws TestFailedException
	{
		AddressFactory af;
		Address addr;

		this.enterSection(ENV_EXPOSED, "Constructor/Accessor");

		af = Address.getAddressFactory();
		try
		{
			addr = af.newAddress(0x00010204,
					     "if/ipv4/udp",
					     "1024:localhost");
			this.test(addr.getANAddress() == 0x00010204);
			this.test(addr.getProtocolSpec().
				  equals("if/ipv4/udp"));
			this.test(addr.getAddressSpec().
				  equals("1024:localhost"));
		}
		catch(NoSuchNodeAddress e)
		{
			throw new TestFailedException(this);
		}
	}

}
