/*
 * FlowClassLoaderTester.Java
 *
 * Copyright (c) 1999, 2000 The University of Utah and the Flux Group.
 * All rights reserved.
 *
 * This file is part of Janos.
 * 
 * Janos is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License, version 2, as
 * published by the Free Software Foundation.
 * 
 * Janos is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details, in the file
 * COPYING.  If that file is not present, write to the Free
 * Software Foundation, 59 Temple Place - Suite 330, Boston, MA  
 * 02111-1307, USA
 * 
 * The University of Utah and the Flux Group requests users to
 * return to flux-dist@cs.utah.edu any improvements that they make.
 */

package JANOS_TESTS_NODEOS_PKG;

import JANOS_TESTS_PKG.*;
import JANOS_NODEOS_PKG.*;

public class FlowClassLoaderTester extends Tester
{
	/* This is pretty basic and could stand to be enhanced quite a bit */
	public void testUnit() throws TestFailedException
	{
		this.enterSection(ENV_EXPOSED, "FlowClassLoader");
#ifdef EXPOSED
		FlowClassLoader fcl;

		this.enterSection(ENV_EXPOSED, "Constructor");
		fcl = new FlowClassLoader(Flow.currentFlow());

		try
		{
			Class cl = fcl.loadClass(JANOS_TESTS_NODEOS_PKG_S
						 + ".FlowClassLoaderTester",
						 true);
		}
		catch(ClassNotFoundException e)
		{
			throw new TestFailedException(this);
		}
		try
		{
			fcl.loadClass(JANOS_TESTS_NODEOS_PKG_S
				      + ".BadFlowClassLoaderTesterClass",
				      true);
			throw new TestFailedException(this);
		}
		catch(ClassNotFoundException e)
		{
		}
#endif
	}
}
