/*
 * NodeOSTester.Java
 *
 * Copyright (c) 1999, 2000 The University of Utah and the Flux Group.
 * All rights reserved.
 *
 * This file is part of Janos.
 * 
 * Janos is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License, version 2, as
 * published by the Free Software Foundation.
 * 
 * Janos is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details, in the file
 * COPYING.  If that file is not present, write to the Free
 * Software Foundation, 59 Temple Place - Suite 330, Boston, MA  
 * 02111-1307, USA
 * 
 * The University of Utah and the Flux Group requests users to
 * return to flux-dist@cs.utah.edu any improvements that they make.
 */

package JANOS_TESTS_NODEOS_PKG;

import JANOS_TESTS_PKG.*;

public class NodeOSTester extends Tester
{
	public void testUnit() throws TestFailedException
	{
		int lpc;

		String classes[] =
		{
			"AddressFactoryTester",
			"AddressTester",
			"BufferHandleTester",
			"BufferTester",
			"ClassInstantiationKeyTester",
			"CommQueueTester",
			"CommSpaceElementTester",
			"CommSpaceHandleTester",
			"CredentialsTester",
			"DemultiplexKeyTester",
			"FlowClassLoaderTester",
			"InChannelTester",
			"OutChannelTester",
			"SemaphoreTester",
			"WorkItemTester"
		};
		
		this.enterSection(ENV_NONE, "NodeOS Classes");
		for( lpc = 0; lpc < classes.length; lpc++ )
		{
			Tester.testClass(JANOS_TESTS_NODEOS_PKG_S
					 + "."
					 + classes[lpc]);
		}
	}
}
